#include <mega128.h>
#include <delay.h>
int b;
char byte[4]; 

#define clock_1() PORTA &= ~(1 << 7);PORTA |= (1 << 7)
#define clock_2() PORTG &= ~(1 << 2);PORTG |= (1 << 2)
#define clock_3() PORTC &= ~(1 << 7);PORTC |= (1 << 7)
#define clock_4() PORTC &= ~(1 << 6);PORTC |= (1 << 6)
#define strob_1() PORTC &= ~(1 << 5);PORTC |= (1 << 5)
#define strob_2() PORTC &= ~(1 << 4);PORTC |= (1 << 4) 
#define strob_3() PORTC &= ~(1 << 3);PORTC |= (1 << 3) 
#define strob_4() PORTC &= ~(1 << 2);PORTC |= (1 << 2)  
#define set_data() PORTA |= 1 << 6
#define clear_data() PORTA &= ~(1 << 6)

void Ports_init(void)
{
    //   
    //DDRF  = 0x00;
    //PORTF = 0x00;
    //DDRA |= 0b00011111;
    //PORTA     &= 0b11100000;
    //   
    //INPUT_SELECT_PORT_DDR |= 0b00111100;
    //INPUT_SELECT_PORT     |= 0b00111100;

    //SIEMENS_SET_OUTPUT(SIEMENS_RST);
    DDRA |= 1 << 5 | 1 << 6 | 1 << 7;
    DDRG |= 1 << 2;
    DDRC |= 1 << 2 | 1 << 3 | 1 << 4 | 1 << 5 | 1 << 6 | 1 << 7;
    PORTA |= 1 << 5 | 1 << 6 | 1 << 7;
    PORTG |= 1 << 2;
    PORTC |= 1 << 2 | 1 << 3 | 1 << 4 | 1 << 5 | 1 << 6 | 1 << 7;
}

void Ports_write(void)
{
    char data, shifter;
        data = byte[0];
        shifter = 0b10000000;
        while(shifter)
        {
            if (data & shifter)
            {
                set_data();
            }
            else
            {
                clear_data();
            }
            clock_1();
            shifter>>=1;
        }
        strob_1();
        data = byte[1];
        shifter = 0b10000000;
        while(shifter)
        {
            if (data & shifter)
			{
				set_data();
			}
			else
			{
				clear_data();
			}
			clock_2();
			shifter>>=1;
		}
		strob_2();
		data = byte[2];
		shifter = 0b10000000;
		while(shifter)
		{
			if (data & shifter)
			{
				set_data();
			}
			else
			{
				clear_data();
			}
			clock_3();
			shifter>>=1;
		}
		strob_3();
		data = byte[3];
		shifter = 0b10000000;
		while(shifter)
		{
			if (data & shifter)
			{
				set_data();
			}
			else
			{
				clear_data();
			}
			clock_4();
			shifter>>=1;
		}
		strob_4();
}



void main(void)
{
    Ports_init();
    //mashine_initial_state();
    //PWM_init();
    //Counter_init();
    //SPI_init();
    //UART_init();
   // Sys_tick_init();
    //mashine_status.message = msg_initialized;
   //sei();
    while(1)
    {
        b++;        
        byte[0]=b;
        byte[1]=b;
        byte[2]=b;
        byte[3]=b;//++;
        Ports_write();
        delay_ms(100);
    }
}